// Code generated by github.com/fjl/gencodec. DO NOT EDIT.

package core

import (
	"encoding/json"
	"errors"
	"math/big"

	"github.com/ethereum/go-ethereum/common"
	"github.com/ethereum/go-ethereum/common/hexutil"
	"github.com/ethereum/go-ethereum/common/math"
	"github.com/ethereum/go-ethereum/params"
)

var _ = (*genesisSpecMarshaling)(nil)

// MarshalJSON marshals as JSON.
func (g Genesis) MarshalJSON() ([]byte, error) {
	type Genesis struct {
		Config     *params.ChainConfig                         `json:"config"`
		Nonce      math.HexOrDecimal64                         `json:"nonce"`
		Timestamp  math.HexOrDecimal64                         `json:"timestamp"`
		ExtraData  hexutil.Bytes                               `json:"extraData"`
		GasLimit   math.HexOrDecimal64                         `json:"gasLimit"   gencodec:"required"`
		Difficulty *math.HexOrDecimal256                       `json:"difficulty" gencodec:"required"`
		Mixhash    common.Hash                                 `json:"mixHash"`
		Coinbase   common.Address                              `json:"coinbase"`
		Alloc      map[common.UnprefixedAddress]GenesisAccount `json:"alloc"      gencodec:"required"`
		Number     math.HexOrDecimal64                         `json:"number"`
		GasUsed    math.HexOrDecimal64                         `json:"gasUsed"`
		ParentHash common.Hash                                 `json:"parentHash"`
		BaseFee    *math.HexOrDecimal256                       `json:"baseFeePerGas"`
		Stake      map[common.UnprefixedAddress]GenesisAccount `json:"stake"      gencodec:"required"`
		//OfficialNFT *types.InjectedOfficialNFT				`json:"injected_official_nft"`
		Dir string												`json:"dir"`
		InjectNumber uint64										`json:"inject_number"`
		StartIndex *big.Int										`json:"start_index"`
		Royalty uint16											`json:"royalty"`
		Creator string 											`json:"creator"`
	}
	var enc Genesis
	enc.Config = g.Config
	enc.Nonce = math.HexOrDecimal64(g.Nonce)
	enc.Timestamp = math.HexOrDecimal64(g.Timestamp)
	enc.ExtraData = g.ExtraData
	enc.GasLimit = math.HexOrDecimal64(g.GasLimit)
	enc.Difficulty = (*math.HexOrDecimal256)(g.Difficulty)
	enc.Mixhash = g.Mixhash
	enc.Coinbase = g.Coinbase
	if g.Alloc != nil {
		enc.Alloc = make(map[common.UnprefixedAddress]GenesisAccount, len(g.Alloc))
		for k, v := range g.Alloc {
			enc.Alloc[common.UnprefixedAddress(k)] = v
		}
	}
	enc.Number = math.HexOrDecimal64(g.Number)
	enc.GasUsed = math.HexOrDecimal64(g.GasUsed)
	enc.ParentHash = g.ParentHash
	enc.BaseFee = (*math.HexOrDecimal256)(g.BaseFee)
	if g.Stake != nil {
		enc.Stake = make(map[common.UnprefixedAddress]GenesisAccount, len(g.Stake))
		for k, v := range g.Stake {
			enc.Stake[common.UnprefixedAddress(k)] = v
		}
	}

	//enc.OfficialNFT = g.OfficialNFT
	enc.Dir = g.Dir
	enc.InjectNumber = g.InjectNumber
	enc.StartIndex = new(big.Int).Set(g.StartIndex)
	enc.Royalty = g.Royalty
	enc.Creator = g.Creator

	return json.Marshal(&enc)
}

// UnmarshalJSON unmarshals from JSON.
func (g *Genesis) UnmarshalJSON(input []byte) error {
	type Genesis struct {
		Config     *params.ChainConfig                         `json:"config"`
		Nonce      *math.HexOrDecimal64                        `json:"nonce"`
		Timestamp  *math.HexOrDecimal64                        `json:"timestamp"`
		ExtraData  *hexutil.Bytes                              `json:"extraData"`
		GasLimit   *math.HexOrDecimal64                        `json:"gasLimit"   gencodec:"required"`
		Difficulty *math.HexOrDecimal256                       `json:"difficulty" gencodec:"required"`
		Mixhash    *common.Hash                                `json:"mixHash"`
		Coinbase   *common.Address                             `json:"coinbase"`
		Alloc      map[common.UnprefixedAddress]GenesisAccount `json:"alloc"      gencodec:"required"`
		Number     *math.HexOrDecimal64                        `json:"number"`
		GasUsed    *math.HexOrDecimal64                        `json:"gasUsed"`
		ParentHash *common.Hash                                `json:"parentHash"`
		BaseFee    *math.HexOrDecimal256                       `json:"baseFeePerGas"`
		Stake      map[common.UnprefixedAddress]GenesisAccount `json:"stake"      gencodec:"required"`
		Validator  map[common.UnprefixedAddress]GenesisAccount `json:"validator"      gencodec:"required"`

		//OfficialNFT *types.InjectedOfficialNFT				`json:"injected_official_nft"`
		Dir string												`json:"dir"`
		InjectNumber uint64										`json:"inject_number"`
		StartIndex *big.Int										`json:"start_index"`
		Royalty uint16											`json:"royalty"`
		Creator string 											`json:"creator"`
	}
	var dec Genesis
	if err := json.Unmarshal(input, &dec); err != nil {
		return err
	}
	if dec.Config != nil {
		g.Config = dec.Config
	}
	if dec.Nonce != nil {
		g.Nonce = uint64(*dec.Nonce)
	}
	if dec.Timestamp != nil {
		g.Timestamp = uint64(*dec.Timestamp)
	}
	if dec.ExtraData != nil {
		g.ExtraData = *dec.ExtraData
	}
	if dec.GasLimit == nil {
		return errors.New("missing required field 'gasLimit' for Genesis")
	}
	g.GasLimit = uint64(*dec.GasLimit)
	if dec.Difficulty == nil {
		return errors.New("missing required field 'difficulty' for Genesis")
	}
	g.Difficulty = (*big.Int)(dec.Difficulty)
	if dec.Mixhash != nil {
		g.Mixhash = *dec.Mixhash
	}
	if dec.Coinbase != nil {
		g.Coinbase = *dec.Coinbase
	}
	if dec.Alloc == nil {
		return errors.New("missing required field 'alloc' for Genesis")
	}
	g.Alloc = make(GenesisAlloc, len(dec.Alloc))
	for k, v := range dec.Alloc {
		g.Alloc[common.Address(k)] = v
	}
	if dec.Number != nil {
		g.Number = uint64(*dec.Number)
	}
	if dec.GasUsed != nil {
		g.GasUsed = uint64(*dec.GasUsed)
	}
	if dec.ParentHash != nil {
		g.ParentHash = *dec.ParentHash
	}
	if dec.BaseFee != nil {
		g.BaseFee = (*big.Int)(dec.BaseFee)
	}
	if dec.Stake == nil {
		return errors.New("missing required field 'stake' for Genesis")
	}
	g.Stake = make(GenesisAlloc, len(dec.Stake))
	for k, v := range dec.Stake {
		g.Stake[common.Address(k)] = v
	}

	if dec.Validator == nil {
		return errors.New("missing required field 'validator' for Genesis")
	}
	g.Validator = make(GenesisAlloc, len(dec.Validator))
	for k, v := range dec.Validator {
		g.Validator[common.Address(k)] = v
	}

	//if dec.OfficialNFT != nil {
	//	g.OfficialNFT.Dir = dec.OfficialNFT.Dir
	//	g.OfficialNFT.StartIndex = new(big.Int).Set(g.OfficialNFT.StartIndex)
	//	g.OfficialNFT.Number = g.OfficialNFT.Number
	//}
	if dec.Dir == "" || dec.StartIndex == nil || dec.InjectNumber == 0 ||
		dec.Royalty == 0 || dec.Creator == "" {
		return errors.New("not init injected official nfts")
	}
	g.Dir = dec.Dir
	g.InjectNumber = dec.InjectNumber
	g.StartIndex = new(big.Int).Set(dec.StartIndex)
	g.Royalty = dec.Royalty
	g.Creator = dec.Creator

	return nil
}
